<script src="@#file#(webgl-math.js)" type="text/javascript"></script>
<script src="@#file#(webgl-basic.js)" type="text/javascript"></script>
<script src="@#file#(webgl-view.js)" type="text/javascript"></script>
<script src="@#file#(webgl-proj.js)" type="text/javascript"></script>

<script type="text/javascript">
  var scene = null;

  function watkinsIdea(canvasID, triangles) {
    var canvas = document.getElementById(canvasID);
    var ctx = canvas.getContext('2d');
    this.bgcolor = 'rgb(255,255,0)';
    this.selectedY = 0;
    this.showOnlyY = false;
    this.wlisteners = [];
    this.indicateY = false;
    this.indicateEdges = false;

    function findXZ(v1, v2, y) {
      var dy = v2[1]-v1[1];
      if(dy==0) return null;
      var t = (y-v1[1])/dy;
      if(t<0 || t>=1) return null;
      return [(v2[0]-v1[0])*t+v1[0], (v2[2]-v1[2])*t+v1[2]];
    }

    function findSegmentsForY(y) {
      var segs = [];
      for(var ti = 0; ti < triangles.length; ti++) {
        var t = triangles[ti];
        var xzs = [];
        var xz = findXZ(t.v1, t.v2, y);
        if(xz!=null) xzs.push(xz);
        xz = findXZ(t.v2, t.v3, y);
        if(xz!=null) xzs.push(xz);
        xz = findXZ(t.v3, t.v1, y);
        if(xz!=null) xzs.push(xz);
        if(xzs.length==2) {
          if(xzs[0][0] > xzs[1][0]) {
            var tmp = xzs[0]; xzs[0] = xzs[1]; xzs[1] = tmp;
          }
          segs.push({triangle: t, points: xzs});
        }
      }
      return segs;
    }

    function drawHorizontalSegment(x0, x1, y, color) {
      ctx.strokeStyle = color;
      ctx.beginPath();
      ctx.moveTo(x0, canvas.height-1-y);
      ctx.lineTo(x1, canvas.height-1-y);
      ctx.stroke();
    } 

    function drawLine(x0, z0, x1, z1, color) {
      ctx.strokeStyle = color;
      ctx.beginPath();
      ctx.moveTo(x0, canvas.height-1-z0);
      ctx.lineTo(x1, canvas.height-1-z1);
      ctx.stroke();
    } 

    function findIntersections(xx0, xx1, activeSegs) {
      for(var i = 0; i < activeSegs.length; i++) {
        let s1 = activeSegs[i];
        let dx1 = s1.points[1][0] - s1.points[0][0];
        let dz1 = s1.points[1][1] - s1.points[0][1];
        let x1  = s1.points[0][0];
        let z1  = s1.points[0][1];
        for(var j = i+1; j < activeSegs.length; j++) {
          let s2 = activeSegs[j];
          let dx2 = s2.points[1][0] - s2.points[0][0];
          let dz2 = s2.points[1][1] - s2.points[0][1];
          let x2  = s2.points[0][0];
          let z2  = s2.points[0][1];
          let det = -dx1*dz2 + dx2*dz1;
          if(Math.abs(det) < 0.00000001) continue;
          let l1 = (-dz2*(x2-x1)+dx2*(z2-z1)) / det;
          let l2 = (-dz1*(x2-x1)+dx1*(z2-z1)) / det;
          if(l1<=0 || l1>=1 || l2<=0 || l2>=1) continue;
          let xs1 = dx1*l1+x1;
          if(xs1>xx0 && xs1<xx1) return xs1;
        }
      }
    }

    function findClosestColor(activeSegs,x) {
      let zmax = null, zi = 0;
      for(var i = 0; i < activeSegs.length; i++) {
        let dx = activeSegs[i].points[1][0]-activeSegs[i].points[0][0];
        if(Math.abs(dx)<0.00000001) continue;
        let t = (x-activeSegs[i].points[0][0])/dx;
        let z = (activeSegs[i].points[1][1]-activeSegs[i].points[0][1])*t+activeSegs[i].points[0][1];
        if(zmax==null || zmax<z) { zmax=z; zi=i; }
      }
      return zmax==null ? 'rgb(0,0,0)' : activeSegs[zi].triangle.color;
    }

    function processScanLine(segments, y, bgcolor) {
      var set = new Set();
      //if(y==100) console.log("Bridovi:");
      for(var i = 0; i < segments.length; i++) {
        set.add(segments[i].points[0][0]);
        set.add(segments[i].points[1][0]);
        //if(y==100) console.log(segments[i]);
      }
      var xes = Array.from(set);
      for(var i = 0; i < segments.length; i++) {
        segments[i].active = false;
      }
      xes.sort(function(a,b) { return a-b; });
      //if(y==100) console.log(xes.toString());
      var xendIndex = 0;
      if(0 < xes[0]) {
        drawHorizontalSegment(0, xes[0], y, bgcolor);
        //if(y==100) console.log("Početno bojam 0 do " + xes[0] +" bojom " + bgcolor);
        xendIndex = 1;
      }
      //if(y==100) console.log("Petlja:");
      for(; xendIndex < xes.length; xendIndex++) {
        var seg = [xes[xendIndex-1], xes[xendIndex]];
        //if(y==100) console.log(seg);
        var activeSegs = [];
        for(var i = 0; i < segments.length; i++) {
          if(segments[i].points[0][0]==seg[0]) {
            segments[i].active = true;
          } else if(segments[i].points[1][0]==seg[0]) {
            segments[i].active = false;
          }
          if(segments[i].active) {
            activeSegs.push(segments[i]);
          }
          //if(y==100) console.log("Brid " + i + "aktivan: " + segments[i].active);
        }
        //if(y==100) console.log("Broj aktivnih: " + activeSegs.length);
        if(activeSegs.length==1) {
          //if(y==100) console.log("Bojam: " + seg[0] + " do "+ seg[1] + " bojom " + activeSegs[0].triangle.color);
          drawHorizontalSegment(seg[0], seg[1], y, activeSegs[0].triangle.color);
        } else if(activeSegs.length>1) { // Mora biti, ali zlu ne trebalo...
          let stog = [];
          while(true) {
            let xsjec = findIntersections(seg[0], seg[1], activeSegs);
            if(!(xsjec==null)) {
              stog.push(seg[1]);
              seg[1] = xsjec;
              continue;
            } else {
              drawHorizontalSegment(seg[0], seg[1], y, findClosestColor(activeSegs,(seg[0]+seg[1])/2));
              if(stog.length==0) break;
              seg[0] = seg[1]; seg[1] = stog.pop();
            }
          }
        }
      }
      if(xes[xes.length-1] < canvas.width) {
        drawHorizontalSegment(xes[xes.length-1], canvas.width, y, bgcolor);
      }
    }

    this.paint = function() {
      ctx.clearRect(0,0,canvas.width,canvas.height);
      for(var y = 0; y < canvas.height; y++) {
        if(this.showOnlyY && this.selectedY!=y) continue;
        var forY = findSegmentsForY(y); // array of {triangle = t, points = [xz,xz]}
        if(this.wlisteners.length>0) {
          for(var wi = 0; wi < this.wlisteners.length; wi++) {
            if(this.wlisteners[wi].whishData(y)) {
              this.wlisteners[wi].acceptData(forY);
            }
          }
        }
        if(forY.length==0) {
          drawHorizontalSegment(0, canvas.width, y, this.bgcolor);
        } else if(forY.length==1) {
          if(0 < forY[0].points[0][0]) drawHorizontalSegment(0, forY[0].points[0][0], y, this.bgcolor);
          drawHorizontalSegment(forY[0].points[0][0], forY[0].points[1][0], y, forY[0].triangle.color);
          if(forY[0].points[1][0] < canvas.width) drawHorizontalSegment(forY[0].points[1][0], canvas.width, y, this.bgcolor);
        } else {
          processScanLine(forY, y, this.bgcolor);
        }
        if(!this.showOnlyY && this.indicateY && y==this.selectedY) {
          drawHorizontalSegment(0, canvas.width, y, 'rgba(255,0,0,255)');
        }
      }
      if(this.indicateEdges) {
        for(var i = 0; i < triangles.length; i++) {
          let t = triangles[i];
          drawLine(t.v1[0],t.v1[1],t.v2[0],t.v2[1], t.color);
          drawLine(t.v2[0],t.v2[1],t.v3[0],t.v3[1], t.color);
          drawLine(t.v3[0],t.v3[1],t.v1[0],t.v1[1], t.color);
        }
      }
    }
  }

  function triangle(v1,v2,v3,color,floatColor) {
    this.v1 = v1;
    this.v2 = v2;
    this.v3 = v3;
    this.color = color;
    this.floatColor = floatColor;
  }

  function watkinsIdeaXZPlotter(canvasID) {
    var canvas = document.getElementById(canvasID);
    var ctx = canvas.getContext('2d');
    var outerThis = this;
    this.forY = 0;
    this.activeSegs = null;

    this.wlistener = new function() {
      this.whishData = function(y) { return y==outerThis.forY; }
      this.acceptData = function(activeSegs, y) {
        outerThis.activeSegs = activeSegs;
        outerThis.paint();
      }
    }

    this.bgcolor = 'rgb(255,255,0)';

    function drawLine(x0, z0, x1, z1, color) {
      ctx.strokeStyle = color;
      ctx.beginPath();
      ctx.moveTo(x0, canvas.height-1-z0);
      ctx.lineTo(x1, canvas.height-1-z1);
      ctx.stroke();
    } 

    this.paint = function() {
      ctx.clearRect(0,0,canvas.width,canvas.height);
      var m = m4$([[1,0,0,0],[0,1,0,0,],[0,0,1,0],[0,0,0,1]]).
              mul([[1,0,0,0],[0,-3,0,0,],[0,0,1,0],[0,0,0,1]]);
      if(this.activeSegs != null) {
        var set = new Set();
        for(let i = 0; i < this.activeSegs.length; i++) {
          let tpt0 = this.activeSegs[i].points[0];
          let tpt1 = this.activeSegs[i].points[1];
          set.add(tpt0[0]);
          set.add(tpt1[0]);
        }
        let arr = Array.from(set);
        for(let i = 0; i < arr.length; i++) {
          let t0 = m.preMul(v$([arr[i],0,0,1]));
          let t1 = m.preMul(v$([arr[i],-200,0,1]));
          drawLine(t0.elems()[0], t0.elems()[1], t1.elems()[0], t1.elems()[1], '#000000');
        }
        for(let i = 0; i < this.activeSegs.length; i++) {
          let tpt0 = this.activeSegs[i].points[0];
          let tpt1 = this.activeSegs[i].points[1];
          let t0 = m.preMul(v$([tpt0[0],tpt0[1],0,1]));
          let t1 = m.preMul(v$([tpt1[0],tpt1[1],0,1]));
          drawLine(t0.elems()[0], t0.elems()[1], t1.elems()[0], t1.elems()[1], this.activeSegs[i].triangle.color);
        }
      }  
    }
  }
  
  var sceneXZ = null;

  function visual3D(canvasID, triangles) {
    var scene3D = new wgl$(canvasID);
    scene3D.forY = 0;
    scene3D.angle = 90;
    scene3D.angle2 = 0;
    scene3D.center = [100, 150, -20];
    scene3D.radius = v$([50, 150, 170]).sub(v$(scene3D.center)).norm();

    this.setAngle = function(a) { scene3D.angle = a; }
    this.setAngle2 = function(a) { scene3D.angle2 = a; }

    scene3D.getProgramsList = function() {
      return [
        [
         "  attribute vec3 vertexPosition;\n" +
         "  attribute vec3 inColor;\n" +
         "  varying lowp vec3 outColor;\n" +
         "\n" +
         "  uniform mat4 mvMatrix;\n" +
         "  uniform mat4 pMatrix;\n" +
         "  \n" +
         "  void main(void) {\n" +
         "    gl_Position = pMatrix * mvMatrix * vec4(vertexPosition, 1.0);\n" +
         "    outColor = inColor;\n" +
         "  }",

         "  varying lowp vec3 outColor;\n" +
         "  void main(void) {\n" +
         "    gl_FragColor = vec4(outColor, 1);\n" +
         "  }"
        ]
      ];
    }

    scene3D.afterCreateProgram = function() {
    }

    scene3D.afterSetup = function() {
      this.gl.clearColor(1.0, 1.0, 0.0, 1.0);
      this.gl.enable(this.gl.DEPTH_TEST);
      this.gl.depthFunc(this.gl.LEQUAL);
      this.gl.disable(this.gl.CULL_FACE);
    }

    scene3D.initBuffers = function() {
      // Spremnik vrhova za kocku:
      // -------------------------
      var bufID = this.gl.createBuffer();
      this.gl.bindBuffer(this.gl.ARRAY_BUFFER, bufID);

      var vertices = [];
      for(var i = 0; i < triangles.length; i++) {
        vertices = vertices.concat(triangles[i].v1);
        vertices = vertices.concat(triangles[i].floatColor);
        vertices = vertices.concat(triangles[i].v2);
        vertices = vertices.concat(triangles[i].floatColor);
        vertices = vertices.concat(triangles[i].v3);
        vertices = vertices.concat(triangles[i].floatColor);
      }

      this.gl.bufferData(this.gl.ARRAY_BUFFER, new Float32Array(vertices), this.gl.STATIC_DRAW);

      this.buffers["vrhovi"] = bufID;

      // Spremnik za koordinatne osi:
      // ----------------------------
      bufID = this.gl.createBuffer();
      this.gl.bindBuffer(this.gl.ARRAY_BUFFER, bufID);

      vertices = [0,0,0, 0,0,0, 300,0,0, 0,0,0, 0,0,0, 0,0,0, 0,300,0, 0,0,0, 0,0,0, 0,0,0, 0,0,300, 0,0,0];

      this.gl.bufferData(this.gl.ARRAY_BUFFER, new Float32Array(vertices), this.gl.STATIC_DRAW);

      this.buffers["osi"] = bufID;

      return true;
    }

    scene3D.display = function() {
      if(!this.setupSuccessful) return;
      this.gl.clear(this.gl.COLOR_BUFFER_BIT | this.gl.DEPTH_BUFFER_BIT);

      this.gl.useProgram(this.programs[0].programID);

      var vertexPositionAttribute = this.gl.getAttribLocation(this.programs[0].programID, 'vertexPosition');
      this.gl.enableVertexAttribArray(vertexPositionAttribute);
      var inColorAttribute = this.gl.getAttribLocation(this.programs[0].programID, 'inColor');
      this.gl.enableVertexAttribArray(inColorAttribute);

      this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.buffers["vrhovi"]);
      this.gl.vertexAttribPointer(vertexPositionAttribute, 3, this.gl.FLOAT, false, 6*4, 0);
      this.gl.vertexAttribPointer(inColorAttribute, 3, this.gl.FLOAT, false, 6*4, 3*4);

      // this.frustum(-2,2,-2,2,3,10), this.translation(-0.5, -1.5, -5)
      //var pMatrix = wgl$.perspectiveProjection(80*3.14/180,4/3,10,500);
      var pMatrix = wgl$.orthographicProjection(-150,150,-70,150, 10, 1000);
      var mvMatrix = m4$(wgl$.identity());
      var center = [100,50,-20];
      var eye = v$(this.center).add([this.radius*Math.cos(this.angle/180*Math.PI),0,this.radius*Math.sin(this.angle/180*Math.PI)]);
      //var rot2 = m4$(wgl$.rotateAroundVector(this.angle2/180*Math.PI, v$([1,0,0]).elems() ));
      var rot2 = m4$(wgl$.rotateAroundVector(this.angle2/180*Math.PI, v$(eye).cross(v$([0,1,0])).elems() ));
      //console.log(rot2);
      //console.log(eye);
      //eye = m4$(wgl$.translation(-center[0],-center[1],-center[2])).mul(rot2).mul(m4$(wgl$.translation(center[0],center[1],center[2]))).postMul(eye).to3d();
      eye = rot2.postMul(eye).to3d();
      //console.log(eye);
      eye = eye.elems();
      var lam = wgl$.lookAt(eye,center,[0,1,0]);

      mvMatrix = m4$(lam).mul(mvMatrix);
      var pUniformID = this.gl.getUniformLocation(this.programs[0].programID, "pMatrix");
      this.gl.uniformMatrix4fv(pUniformID, false, m4$.float32array(pMatrix));

      var mvUniformID = this.gl.getUniformLocation(this.programs[0].programID, "mvMatrix");
      this.gl.uniformMatrix4fv(mvUniformID, false, m4$.float32array(mvMatrix));

      this.gl.drawArrays(this.gl.TRIANGLES, 0, 6);

      var y = this.forY;
      var pm = 200;
      var rr=1, rg=1, rb=1;
      var bufID = this.gl.createBuffer();
      this.gl.bindBuffer(this.gl.ARRAY_BUFFER, bufID);
      var vertices = [-pm,y,pm, rr,rg,rb, pm,y,pm, rr,rg,rb, pm,y,-pm, rr,rg,rb, pm,y,-pm, rr,rg,rb, -pm,y,-pm, rr,rg,rb, -pm,y,pm, rr,rg,rb];
      this.gl.bufferData(this.gl.ARRAY_BUFFER, new Float32Array(vertices), this.gl.STATIC_DRAW);

      this.gl.vertexAttribPointer(vertexPositionAttribute, 3, this.gl.FLOAT, false, 6*4, 0);
      this.gl.vertexAttribPointer(inColorAttribute, 3, this.gl.FLOAT, false, 6*4, 3*4);

      mvMatrix = m4$(wgl$.identity());
      mvMatrix = m4$(lam).mul(mvMatrix);
      this.gl.uniformMatrix4fv(mvUniformID, false, m4$.float32array(mvMatrix));

      this.gl.drawArrays(this.gl.TRIANGLES, 0, 6);
      this.gl.deleteBuffer(bufID);

      bufID = this.gl.createBuffer();
      this.gl.bindBuffer(this.gl.ARRAY_BUFFER, bufID);
      var lr=0.8, lg=0.8, lb=0.8;
      vertices = [];
      var step = 50;
      var n = 0;
      for(var k = -pm; k < pm; k += step) {
        vertices = vertices.concat([k, y, -pm, lr, lg, lb, k, y, pm, lr, lg, lb]);
        vertices = vertices.concat([-pm, y, k, lr, lg, lb, pm, y, k, lr, lg, lb]);
        n+=4;
      }
      this.gl.bufferData(this.gl.ARRAY_BUFFER, new Float32Array(vertices), this.gl.STATIC_DRAW);

      this.gl.vertexAttribPointer(vertexPositionAttribute, 3, this.gl.FLOAT, false, 6*4, 0);
      this.gl.vertexAttribPointer(inColorAttribute, 3, this.gl.FLOAT, false, 6*4, 3*4);

      this.gl.drawArrays(this.gl.LINES, 0, n);
      this.gl.deleteBuffer(bufID);

      this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.buffers["osi"]);
      this.gl.vertexAttribPointer(vertexPositionAttribute, 3, this.gl.FLOAT, false, 6*4, 0);
      this.gl.vertexAttribPointer(inColorAttribute, 3, this.gl.FLOAT, false, 6*4, 3*4);

      mvMatrix = m4$(wgl$.identity());
      mvMatrix = m4$(lam).mul(mvMatrix);
      this.gl.uniformMatrix4fv(mvUniformID, false, m4$.float32array(mvMatrix));

      this.gl.drawArrays(this.gl.LINES, 0, 6);

    }

    scene3D.setup();

    this.scene3D = scene3D;
    this.setForY = function(y) { scene3D.forY = y; }
    this.paint = function() { this.scene3D.display(); }
  }

  var scenev3d = null;

  function start() {
    var t1 = new triangle([20,20,-10],[80,180,-20],[135,30,-15], 'rgb(0,255,0)', [0,1,0]);
    var t2 = new triangle([10,30,-30],[70,110,-5],[140,60,-40], 'rgb(0,0,255)', [0,0,1]);
    scene = new watkinsIdea('myCanvas', [t1,t2]);
    sceneXZ = new watkinsIdeaXZPlotter('myCanvas2');
    scene.wlisteners.push(sceneXZ.wlistener);
    scenev3d = new visual3D('myCanvas3', [t1,t2]);
    scene.paint();
    scenev3d.paint();
  }
</script>

  <p>Ova minilekcija sadrži samo jednu stranicu s interaktivnom demonstracijom koja Vam omogućava da kroz
  dani primjer istražite rad Watkinsovog algoritma za prikazivanje 3D scene (odnosno određivanje vidljivosti 
  na razini pojedinih scan-linija). Postupak računa vidljivosti liniju po liniju, počev od y=0 pa do y=y<sub>max</sub>.
  </p>

 <p>Prvi kliznik omogućava da odredite koju sken-liniju želite prikazati (uključite li "Prikaži samo zadanu sken-liniju" - u prvom platnu
    ćete vidjeti rezultat koji generira samo ona).</p>
 <p>3D scena prikazana je desno, gdje drugim i trećim kliznikom možete rotirati promatrača kako biste stekli dojam kako
    su trokuti postavljeni u prostoru. Te promjene međutim ne pomiču promatrača koji generira sliku Watkinsovim algoritmom:
    on je u ovom primjeru uvijek u ishodištu koordinatnog sustava i gleda u smjeru osi -<i>z</i>.
 </p>
 <p>Platno prikazano u drugom redu lijevo prikazuje sjecišta i njihove udaljenosti od ravnine projekcije koje trokuti
    stvaraju s ravninom y=y<sub>i</sub>, gdje y<sub>i</sub> određuje sken-liniju; ta je ravnina također prikazana u 3D prikazu u prvom redu desno.
 </p>

<table style="width: 80%">
<tr>
<td valign="top">
  <canvas id="myCanvas" width="300" height="200" style="border: 1px solid black;">
    Your browser doesn't appear to support the 
    &lt;canvas&gt; element.
  </canvas><br>
  a) Slika koju generira Watkinsov algoritam<br>
</td>
<td valign="top">
  <canvas id="myCanvas3" width="300" height="200" style="border: 1px solid black;">
    Your browser doesn't appear to support the 
    &lt;canvas&gt; element.
  </canvas><br>
  b) 3D scena i presjek s ravninom y = <span id="sltvalx">90</span><br>(tj. sken-linijom u 2D)
</td>
</tr>
<tr>
<td valign="top" style="padding-top: 20px;">
  <canvas id="myCanvas2" width="300" height="200" style="border: 1px solid black;">
    Your browser doesn't appear to support the 
    &lt;canvas&gt; element.
  </canvas><br>
  c) Presjecište ravnine i trokuta<br>prikazano u xz ravnini<br>(promatrač je na dnu,<br>gleda prema gore)
</td>
<td valign="top" style="padding-top: 20px;">
  0 <input style="width: 50%; display: inline;" type="range" min="0" max="199" step="1" value="0" oninput="document.getElementById('sltval').innerHTML=this.value; document.getElementById('sltvalx').innerHTML=this.value; scene.selectedY = this.value; sceneXZ.forY = this.value; scene.paint(); scenev3d.setForY(this.value); scenev3d.paint();"> 199 (trenutno: <span id="sltval">0</span>)<br>
  -180° <input style="width: 50%; display: inline;" type="range" min="-180" max="180" step="10" value="90" oninput="document.getElementById('sltval2').innerHTML=this.value; scenev3d.setAngle(this.value); scenev3d.paint();"> 180° (trenutno: <span id="sltval2">90</span>°)<br>
  -180° <input style="width: 50%; display: inline;" type="range" min="-180" max="180" step="10" value="0" oninput="document.getElementById('sltval3').innerHTML=this.value; scenev3d.setAngle2(this.value); scenev3d.paint();"> 180° (trenutno: <span id="sltval3">0</span>°)<br>
  <input type="checkbox" onchange="scene.showOnlyY = this.checked; scene.paint();">Prikaži samo zadanu sken-liniju.<br>
  <input type="checkbox" onchange="scene.indicateY = this.checked; scene.paint();">Skiciraj sken-liniju.<br>
  <input type="checkbox" onchange="scene.indicateEdges = this.checked; scene.paint();">Označi stranice trokuta.<br><br>
  Kliznikom za sken-liniju možete podesiti<br>y-koordinatu koja se analizira. U 3D sceni<br>možete rotirati kameru uporabom kliznika<br>za stupnjeve. U početnom 3D prikazu x-os<br>gleda u desno, y-os prema gore, z-os<br> prema Vama.<br><br>
  d) Kontrole
</td>
</tr>
</table>

<script type="text/javascript">
start();
</script>
